#!/bin/bash

for i in 1 2 3 4 5 6; do
    new_seed=`expr 12345670 + 2 \* $i - 1`
    ns create-traffic-file-tcp.tcl -seed $new_seed -nn 116 -filesize 10000 > trafficgen_tcp.tcl
    sleep 5
    nice -n 4 ns bundle-test-large-scen-aodv.tcl -seed $new_seed -nn 116 -simtime 3600.0 > aodv.txt
    grep 'send'  trafficgen_tcp.tcl > temp.tcl
    mv temp.tcl trafficgen_tcp.tcl
    awk '{print $3" "$4}' trafficgen_tcp.tcl > temp.txt
    sed -i 's/"$ftp_(//g' temp.txt
    sed -i 's/)//g' temp.txt
    mv temp.txt send_times.tr
    grep 'Source' aodv.txt > temp.txt
    awk '{print $2" "$12" "$16}' temp.txt > ack_times.tr
    rm temp.txt
    mv *.tr *.txt trafficgen_tcp.tcl Run$i
done
