#!/bin/bash

for i in 1 2 3 4 5 6; do
    new_seed=`expr 12345670 + 2 \* $i - 1`
    nice -n 4 ns bundle-test-large-scen.tcl -seed $new_seed -nn 116 -simtime 3600.0 -bundlesize 10000 -lifetime 750.0 > dtn.txt
    grep 'Destination' dtn.txt > temp.txt
    awk '{print $6" "$10" "$14" "$18}' temp.txt > bundle_delays.tr
    sed -i 's/, / /g' bundle_delays.tr
    grep 'receipt' dtn.txt > temp.txt
    awk '{print $2" "$10" "$14" "$18}' temp.txt > receipt_delays.tr
    sed -i 's/, / /g' receipt_delays.tr

    grep 'ping'  ttrace.tr > temp.txt
    awk '{print $3" "$4}' temp.txt > ping_send_times.tr
    sed -i 's/"$ftp_(//g' ping_send_times.tr
    sed -i 's/)//g' ping_send_times.tr

    grep 'send'  ttrace.tr > temp.txt
    awk '{print $3" "$4}' temp.txt > send_times.tr
    sed -i 's/"$ftp_(//g' send_times.tr
    sed -i 's/)//g' send_times.tr
    grep 'ack' dtn.txt > temp.txt
    awk '{print $2" "$12" "$16}' temp.txt > ack_times.tr

    rm temp.txt
    mv *.tr *.txt Run$i
done
